CREATE OR REPLACE PROCEDURE EAM_IMPORTA_RECEBIMENTO(V_ERRO OUT VARCHAR2)
IS
   V_CODTRANSACAO VARCHAR2(44);
   V_BANCO        VARCHAR2(3);
   V_AGENCIA      VARCHAR2(5);
   V_CONTCORR     VARCHAR2(20);
   V_CDTPBAIXAREC VARCHAR2(2);
   --V_IDTIPORECE   VARCHAR2(1);
   V_DATABAIXA    DATE;
	V_DTLIQUIDACAO DATE;
	V_DTIMPORTACAO DATE;
   V_VRBAIXA      FLOAT;
   V_OBSERVACAO   VARCHAR2(250);
   V_CODAJUSTE    VARCHAR2(4);
   V_CDFILIALNF VARCHAR2(4);
   V_NRLANCTONF VARCHAR2(10);
   --V_CDFILIAL   VARCHAR2(4);
   V_CDCLIENTE  VARCHAR2(21);
   --V_CDSERIE    VARCHAR2(5);
   V_CDEMPRESA  VARCHAR2(2);
   V_IDENTRSAID VARCHAR2(1);
   --V_IDSTATUS   VARCHAR2(1);
   V_CDREDUCONT  VARCHAR2(3);
   V_CDAJUCTREC  VARCHAR2(4);
   V_VRNOTAFISC  FLOAT;
   V_CDTPCTRECEB VARCHAR2(6);
   V_DSTPCTRECEB VARCHAR2(40);
   V_CDCLASSFINA VARCHAR2(6);
   V_NFREC       VARCHAR2(20);
   --V_NRLANCCONT  VARCHAR2(20);
   --V_STNRBOLETO  VARCHAR2(20);
   V_NRLANBOLREC VARCHAR2(20);
	V_CDFILIBOLREC VARCHAR2(4);
   V_CDOPERADOR  VARCHAR2(12);
   V_NRBAIXAREC  VARCHAR2(20);
   --V_CDFILIALREC VARCHAR2(4);
   V_NRLANCTOREC VARCHAR2(10);
   V_NRSEQVENREC VARCHAR2(2);
   V_STATUSBOLETO VARCHAR2(1);
   --V_DTBAIXA     DATE;
   V_NRPARCELAREC VARCHAR2(2);
   V_VRSDOCCORR FLOAT;
   V_AJUSTE VARCHAR2(1); -- D: DESCONTO / A: ACRSCIMO
   V_CDTPBAIXA VARCHAR2(2);
   V_CONT INTEGER;
   V_PRXMOVBANC VARCHAR2(20);
   V_NRRECIBOREC VARCHAR2(20);
   V_NRLCTBBREC VARCHAR2(20);
   V_DTMOVFLUXO DATE;
   V_IDSTATREC VARCHAR2(1); -- STATUS DA CONTA A RECEBER
   --V_ERRO VARCHAR2(500);
   V_ROWID UROWID;
   V_CODBOLETO VARCHAR2(20);
   V_IDSTATBREC VARCHAR2(1);
   V_COUNTERRO   FLOAT;
   CURSOR C_RECEBIMENTO IS
      SELECT CODTRANSACAO, BANCO, AGENCIA, CONTCORR, CDTPBAIXAREC, /*IDTIPORECE,*/ DATABAIXA, VRBAIXA,
             OBSERVACAO, CODAJUSTE, DTIMPORTACAO, DATAPAGTO, CODBOLETO, ROWID
        FROM USR_EAM_RECEBIMENTO
       WHERE DTIMPORTACAO IS NULL
         AND ERRO IS NULL;
BEGIN
   OPEN C_RECEBIMENTO;
   LOOP
      FETCH C_RECEBIMENTO INTO V_CODTRANSACAO, V_BANCO, V_AGENCIA, V_CONTCORR, V_CDTPBAIXAREC, /*V_IDTIPORECE,*/ V_DATABAIXA, V_VRBAIXA,
                               V_OBSERVACAO, V_CODAJUSTE,V_DTIMPORTACAO, V_DTLIQUIDACAO,V_CODBOLETO, V_ROWID;
      EXIT WHEN C_RECEBIMENTO%NOTFOUND;
      V_ERRO := NULL;
      BEGIN
         SELECT MAX(CDFILIAL), MAX(NRLANBOLREC), MAX(IDSTATBREC) 
           INTO V_CDFILIBOLREC, V_NRLANBOLREC, V_IDSTATBREC
           FROM BOLETRECEBER
          WHERE USR_CODBOLETO = V_CODBOLETO;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_ERRO := 'NO FOI ENCONTRADO O BOLETO REFERENTE AO CDIGO '||V_CODBOLETO;
            V_CDFILIBOLREC := NULL;
         WHEN OTHERS THEN
            V_ERRO := SQLERRM(SQLCODE);
            V_CDFILIBOLREC := NULL;
      END;
      
      IF (V_CDFILIBOLREC IS NOT NULL) THEN
         SELECT COUNT(1)
           INTO V_CONT
           FROM BANCO
          WHERE CDBANCO = V_BANCO;
         IF (V_CONT = 1) THEN
            SELECT COUNT(1)
              INTO V_CONT
              FROM AGENCIA
             WHERE CDBANCO   = V_BANCO
               AND CDAGENCIA = V_AGENCIA;
            IF (V_CONT = 1) THEN
               BEGIN
                  SELECT CDREDUCONT
                    INTO V_CDREDUCONT
                    FROM CONTCORR
                   WHERE CDBANCO    = V_BANCO
                     AND CDAGENCIA  = V_AGENCIA
                     AND CDCONTCORR = V_CONTCORR;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_CDREDUCONT := NULL;
                     V_ERRO := 'NO FOI ENCONTRADO UMA CONTA CORRENTE REFERENTE AO BANCO '||V_BANCO||'E AGNCIA '||V_AGENCIA||', COM O CDIGO '||V_CONTCORR;
                  WHEN OTHERS THEN
                     V_CDREDUCONT := NULL;
                     V_ERRO := SQLERRM(SQLCODE);
               END;
               IF (V_CDREDUCONT IS NOT NULL) THEN
                  BEGIN
                     SELECT CDTPBAIXAREC
                       INTO V_CDTPBAIXA
                       FROM TIPOBAIXAREC
                      WHERE CDTPBAIXAREC = V_CDTPBAIXAREC;
                  EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                        V_ERRO := 'CDIGO DO TIPO DE BAIXA '||V_CDTPBAIXAREC||' NO CADASTRADO';
                  END;
               END IF;
					IF (V_ERRO IS NULL) THEN	
						
                  BEGIN
                     SELECT IDSTATBREC
                       INTO V_IDSTATBREC
                       FROM BOLETRECEBER
                      WHERE USR_CODBOLETO = V_CODBOLETO;
                  EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                        V_IDSTATBREC := NULL;                       
                  END;
              
                  IF (V_IDSTATBREC = 'A') THEN
						
							BEGIN
                        SELECT  MAX(NF.CDEMPRESA), MAX(C.DTMOVFLUXO), MAX(CDCLASSFINA) 
                          INTO V_CDEMPRESA, V_DTMOVFLUXO,V_CDCLASSFINA
                          FROM NOTAFISCAL NF, CONTARECEBER C, BOLETRECEBER BO
                         WHERE NF.CDFILIAL   = C.CDFILIAL
                           AND NF.NRLANCTONF = C.NRLANCTONF
                           AND BO.NRLANBOLREC = C.NRLANBOLREC
									AND BO.CDFILIAL = C.CDFILIBOLREC
									AND BO.USR_CODBOLETO = V_CODBOLETO;
                     EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                           V_CDEMPRESA := NULL;
                           --V_IDSTATUS  := NULL;
                           V_ERRO := 'NO FOI ENCONTRADO O LANAMENTO DA NOTA FISCAL REFERENTE A TRANSAO '||V_CODTRANSACAO;
                     END;
                     BEGIN
                        SELECT MAX(CDOPERADOR)
                          INTO V_CDOPERADOR
                          FROM FILIOPER
                         WHERE CDFILIAL = V_CDFILIBOLREC;
                        IF (V_CDOPERADOR IS NOT NULL) THEN
                           NOVO_CODIGO_NT('MOVBANCARIO'||V_CDREDUCONT, V_PRXMOVBANC);
                           NOVO_CODIGO_NT('BAIXARECEBIDA'||V_CDFILIBOLREC, V_NRBAIXAREC);
                           NOVO_CODIGO_NT('LISTA', V_NRRECIBOREC);
                           V_PRXMOVBANC  := SUBSTR(V_PRXMOVBANC, -10);
                           V_NRRECIBOREC := SUBSTR(V_NRRECIBOREC, -10);
                           V_NRBAIXAREC  := SUBSTR(V_NRBAIXAREC, -10);
                           BEGIN
                              /* TESTAR SE O FLUXO EXISTE */
                              SELECT COUNT(1)
                                INTO V_CONT
                                FROM MOVFLUXO
                               WHERE CDCLASSFINA = V_CDCLASSFINA
                                 AND CDEMPRESA   = V_CDEMPRESA
                                 AND CDFILIAL    = V_CDFILIBOLREC
                                 AND DTMOVFLUXO  = V_DTMOVFLUXO
                                 AND IDMOVFLUXO  = 'E';
                              IF (V_CONT = 0) THEN
                                 INSERT INTO MOVFLUXO(CDCLASSFINA, CDEMPRESA, CDFILIAL, DTMOVFLUXO, IDMOVFLUXO, VRENTMFLUXO, VRSAIMFLUXO)
                                 VALUES(V_CDCLASSFINA, V_CDEMPRESA, V_CDFILIBOLREC, V_DTMOVFLUXO, 'E', V_VRBAIXA, 0);
                              ELSE
                                 UPDATE MOVFLUXO
                                    SET VRENTMFLUXO = VRENTMFLUXO + V_VRBAIXA
                                  WHERE CDCLASSFINA = V_CDCLASSFINA
                                    AND CDEMPRESA   = V_CDEMPRESA
                                    AND CDFILIAL    = V_CDFILIBOLREC
                                    AND DTMOVFLUXO  = V_DTMOVFLUXO
                                    AND IDMOVFLUXO  = 'E';
                              END IF;
                              UPDATE CONTARECEBER
                                 SET IDMOVFLUXO = 'E',
                                     IDSTATREC  = 'B',
                                     DTMOVFLUXO = V_DTMOVFLUXO
                                WHERE CDFILIBOLREC||NRLANBOLREC = (SELECT BO.CDFILIAL||BO.NRLANBOLREC
                                                                   FROM BOLETRECEBER BO
                                                                   WHERE USR_CODBOLETO = V_CODBOLETO);
                              INSERT INTO MOVBANCARIO(CDREDUCONT, NRMOVBANC, DTMOVBANC, IDMOVBANC, DSHISMBANC, VRMOVBANC, IDORIGMBANC)
                              VALUES(V_CDREDUCONT, V_PRXMOVBANC, V_DTMOVFLUXO, 'C', 'Integrao', V_VRBAIXA, 'R');
                              INSERT INTO BAIXARECEBIDA(CDEMPRESA, NRMOVBANC, /*NRLCTBBREC,*/ NRBAIXAREC, NRRECIBOREC, IDSTATUSBREC, CDFILIAL,
                                                        DTBAIXAREC, VRBAIXAREC, CDREDUCONT, CDTPBAIXAREC, CDOPERADOR, DTLANCBAIXAR)
                              VALUES(V_CDEMPRESA, V_PRXMOVBANC, /*V_NRLCTBBREC,*/ V_NRBAIXAREC, V_NRRECIBOREC, 'E', V_CDFILIBOLREC,
                                     V_DATABAIXA, V_VRBAIXA, V_CDREDUCONT, V_CDTPBAIXAREC, V_CDOPERADOR, V_DTIMPORTACAO);
                              UPDATE BOLETRECEBER
                                 SET IDSTATBREC   = 'B',
                                     NRBAIXAREC   = V_NRBAIXAREC,
                                     CDTPBAIXAREC = V_CDTPBAIXAREC,
                                     CDFILIBAIREC = V_CDFILIBOLREC,
                                     DTLIQBOLREC  = V_DTLIQUIDACAO,
                                     CDREDUCONT   = V_CDREDUCONT
                               WHERE (CDFILIAL    = V_CDFILIBOLREC)
                                 AND (NRLANBOLREC = V_NRLANBOLREC);
                              CTB_REC_BAIXA(V_CDEMPRESA ,V_CDFILIBOLREC, V_CDFILIBOLREC, V_NRBAIXAREC,  V_NRLCTBBREC);
                              BEGIN
                                  SELECT COUNT(*)
                                    INTO V_COUNTERRO
                                    FROM ERROCTBTEMP
                                   WHERE NRLANCCTBTEMP = V_NRLCTBBREC;
                               EXCEPTION
                                    WHEN NO_DATA_FOUND THEN
                                         V_COUNTERRO := 0;
                               END;
                               IF V_COUNTERRO <> 0 THEN
                                  V_ERRO := 'OCORRERAM ERROS NA CONTABILIZAO DA BAIXA';
                               END IF;
                                ATUALIZA_SALDO_BANCARIO(V_CDREDUCONT, V_DATABAIXA, ABS(V_VRBAIXA), '1');
                           EXCEPTION
                              WHEN OTHERS THEN
                                 V_ERRO := SQLERRM(SQLCODE);
                           END;
                        ELSE
                           V_ERRO := 'NO EXISTE OPERADOR RELACIONADO A FILIAL '||V_CDFILIBOLREC;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                           ROLLBACK;
                           V_ERRO := SQLERRM(SQLCODE);
                     END;
                  END IF;
					END IF;
            ELSE
               V_ERRO := 'NO FOI ENCONTRADA AGNCIA COM O CDIGO '||V_AGENCIA||' RELACIONADA AO BANCO '||V_BANCO;
            END IF;
         ELSE
            V_ERRO := 'NO FOI ENCONTRADO BANCO COM O CDIGO '||V_BANCO;
         END IF;
      END IF;
      IF (V_ERRO IS NULL) THEN
        
         UPDATE USR_EAM_RECEBIMENTO
            SET DTIMPORTACAO = SYSDATE
          WHERE CODTRANSACAO = V_CODTRANSACAO;
      ELSE
         UPDATE USR_EAM_RECEBIMENTO
            SET ERRO = V_ERRO
          WHERE CODTRANSACAO = V_CODTRANSACAO;
      END IF;
      COMMIT;
   END LOOP;
   CLOSE C_RECEBIMENTO;
   COMMIT;
EXCEPTION
   WHEN OTHERS THEN
      V_ERRO := SQLERRM(SQLCODE);
      UPDATE USR_EAM_RECEBIMENTO
         SET ERRO = V_ERRO
       WHERE CODTRANSACAO = V_CODTRANSACAO;
      IF C_RECEBIMENTO%ISOPEN THEN
         CLOSE C_RECEBIMENTO;
      END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('EAM_IMPORTA_RECEBIMENTO','6.35.027'); END;
/
