var AlterSenha = function(ScreenService, MessageService, ChecaEmail, SignIn) {
/* global Constants */
	var comparaCampos = function(primeiroCampo, segundoCampo) {

		if(primeiroCampo != segundoCampo) {

			MessageService.notificationMessageByCode("passwordNotMatch", null, Constants.errorNotification);
			return false;
		}

		return true;

	};

	this.alterSenhaPopup = function(widgetAlterSenha){

		ScreenService.openPopup(widgetAlterSenha);

	};

	this.confirmar = function(gridWidget, widget, widgetPopupAltSenha) {

		if(widget.isValid()){

			var email = widget.currentRow.emailParaVerificacao;

			ChecaEmail.verificaEmail(email).then(function() {

				MessageService.showMessageByCode("checkEmail", {EMAIL: email}, Constants.infoMessage);

				ScreenService.openPopup(widgetPopupAltSenha);
				widgetPopupAltSenha.newRow();

			}, function(callback) {

				if (callback.data) {

					ScreenService.showMessage(callback.data.error, 'E');

				} else {

					MessageService.showMessageByCode("checkYourConnection", null, Constants.errorMessage);
					
				}

			});

		}

	};

	this.cancel = function(gridWidget) {

		ScreenService.closePopup(true);
		gridWidget.activate();

	};

	this.confirmarAltSenha = function(gridWidget, widgetPopupEmail, widget){

		var email = widgetPopupEmail.currentRow.emailParaVerificacao;
		var codigo = widget.currentRow.cdRandomAcesso;
		var novaSenha = widget.currentRow.novaSenha;
		var confirmaSenha = widget.currentRow.confirmaNovaSenha;

		if(widget.isValid()){

			if(comparaCampos(novaSenha, confirmaSenha)){

				ChecaEmail.consultaCodigoDeAtivacao(email, codigo, novaSenha).then(function() {

					MessageService.showMessageByCode("passwordChanged", null, Constants.infoMessage);

					ScreenService.closePopup(true);
					gridWidget.activate();


				}, function(callback){

					if (callback.data) {

						ScreenService.showMessage(callback.data.error, 'E');

					} else {

						MessageService.showMessageByCode("checkYourConnection", null, Constants.errorMessage);

					}

				});

			}

		}

	};

	this.alteraSenha = function(formWidget, widgetPopup){

		var email = getLocalVar('DSLOGINECO');
		var fornecedor = getLocalVar('CDFORNECED');
		var senhaAtual = widgetPopup.currentRow.senhaAtual;
		var novaSenha = widgetPopup.currentRow.senhaNova;
		var confirmaSenha = widgetPopup.currentRow.senhaConfirmacao;

		if(widgetPopup.isValid()){

			if(comparaCampos(novaSenha, confirmaSenha)){

				SignIn.auth(fornecedor, email, senhaAtual).then(function() {

					ChecaEmail.alteraSenha(email, novaSenha);

					MessageService.showMessageByCode("passwordChanged", null, Constants.infoMessage);

					ScreenService.closePopup(true);
					formWidget.activate();

				},function(exceptionMessage) {
					ScreenService.showMessage(exceptionMessage.data.error);
				});

			}

		}

	};

};

Configuration(function(ContextRegister) {
	ContextRegister.register('AlterSenha', AlterSenha);
});
